from model.DateUtils import DateUtils
from app.api_data.tx_ad_cost import get_cost_older
from app.etl.data_stat_run import do_cost
from app.etl.dm.dm_pitcher_daily_overview import dm_pitcher_daily_overview
from app.etl.dw.dw_channel_daily import dw_channel_daily
from app.etl.dw.dw_pitcher_daily import dw_pitcher_trend
from app.etl.src.src_book_info import src_book_info
from app.etl.dw.dw_book_trend import book_trend

du = DateUtils()


def get_data():
    #1.获取数据
    st = du.get_n_days(-2)
    et = du.get_n_days(0)
    print(st, et)
    get_cost_older.run(st, et)

    #同步到ck
    do_cost(st, et)

    #2.数据处理
    src_book_info()  # 书籍卡点信息
    # book_annual_expect_profit.run() # 年预期收益
    dw_channel_daily()
    dw_pitcher_trend()
    book_trend()
    dm_pitcher_daily_overview()



if __name__=="__main__":
    get_data()